/*
polyprint.v1

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package polyprintapi

import (
	"encoding/json"
)

// checks if the CreatePrintOrderRequestProductionData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreatePrintOrderRequestProductionData{}

// CreatePrintOrderRequestProductionData struct for CreatePrintOrderRequestProductionData
type CreatePrintOrderRequestProductionData struct {
	ReferenceId interface{} `json:"referenceId"`
	Date interface{} `json:"date"`
	ProductId interface{} `json:"productId"`
	Quantity interface{} `json:"quantity"`
	DeliveryContact PolyprintContact `json:"deliveryContact"`
	BillingContact PolyprintContact `json:"billingContact"`
	ExpectedDeliveryDate interface{} `json:"expectedDeliveryDate"`
	NfcCode interface{} `json:"nfcCode,omitempty"`
}

// NewCreatePrintOrderRequestProductionData instantiates a new CreatePrintOrderRequestProductionData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreatePrintOrderRequestProductionData(referenceId interface{}, date interface{}, productId interface{}, quantity interface{}, deliveryContact PolyprintContact, billingContact PolyprintContact, expectedDeliveryDate interface{}) *CreatePrintOrderRequestProductionData {
	this := CreatePrintOrderRequestProductionData{}
	this.ReferenceId = referenceId
	this.Date = date
	this.ProductId = productId
	this.Quantity = quantity
	this.DeliveryContact = deliveryContact
	this.BillingContact = billingContact
	this.ExpectedDeliveryDate = expectedDeliveryDate
	return &this
}

// NewCreatePrintOrderRequestProductionDataWithDefaults instantiates a new CreatePrintOrderRequestProductionData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreatePrintOrderRequestProductionDataWithDefaults() *CreatePrintOrderRequestProductionData {
	this := CreatePrintOrderRequestProductionData{}
	return &this
}

// GetReferenceId returns the ReferenceId field value
// If the value is explicit nil, the zero value for interface{} will be returned
func (o *CreatePrintOrderRequestProductionData) GetReferenceId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}

	return o.ReferenceId
}

// GetReferenceIdOk returns a tuple with the ReferenceId field value
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CreatePrintOrderRequestProductionData) GetReferenceIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ReferenceId) {
		return nil, false
	}
	return &o.ReferenceId, true
}

// SetReferenceId sets field value
func (o *CreatePrintOrderRequestProductionData) SetReferenceId(v interface{}) {
	o.ReferenceId = v
}

// GetDate returns the Date field value
// If the value is explicit nil, the zero value for interface{} will be returned
func (o *CreatePrintOrderRequestProductionData) GetDate() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}

	return o.Date
}

// GetDateOk returns a tuple with the Date field value
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CreatePrintOrderRequestProductionData) GetDateOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Date) {
		return nil, false
	}
	return &o.Date, true
}

// SetDate sets field value
func (o *CreatePrintOrderRequestProductionData) SetDate(v interface{}) {
	o.Date = v
}

// GetProductId returns the ProductId field value
// If the value is explicit nil, the zero value for interface{} will be returned
func (o *CreatePrintOrderRequestProductionData) GetProductId() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}

	return o.ProductId
}

// GetProductIdOk returns a tuple with the ProductId field value
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CreatePrintOrderRequestProductionData) GetProductIdOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ProductId) {
		return nil, false
	}
	return &o.ProductId, true
}

// SetProductId sets field value
func (o *CreatePrintOrderRequestProductionData) SetProductId(v interface{}) {
	o.ProductId = v
}

// GetQuantity returns the Quantity field value
// If the value is explicit nil, the zero value for interface{} will be returned
func (o *CreatePrintOrderRequestProductionData) GetQuantity() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}

	return o.Quantity
}

// GetQuantityOk returns a tuple with the Quantity field value
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CreatePrintOrderRequestProductionData) GetQuantityOk() (*interface{}, bool) {
	if o == nil || IsNil(o.Quantity) {
		return nil, false
	}
	return &o.Quantity, true
}

// SetQuantity sets field value
func (o *CreatePrintOrderRequestProductionData) SetQuantity(v interface{}) {
	o.Quantity = v
}

// GetDeliveryContact returns the DeliveryContact field value
func (o *CreatePrintOrderRequestProductionData) GetDeliveryContact() PolyprintContact {
	if o == nil {
		var ret PolyprintContact
		return ret
	}

	return o.DeliveryContact
}

// GetDeliveryContactOk returns a tuple with the DeliveryContact field value
// and a boolean to check if the value has been set.
func (o *CreatePrintOrderRequestProductionData) GetDeliveryContactOk() (*PolyprintContact, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DeliveryContact, true
}

// SetDeliveryContact sets field value
func (o *CreatePrintOrderRequestProductionData) SetDeliveryContact(v PolyprintContact) {
	o.DeliveryContact = v
}

// GetBillingContact returns the BillingContact field value
func (o *CreatePrintOrderRequestProductionData) GetBillingContact() PolyprintContact {
	if o == nil {
		var ret PolyprintContact
		return ret
	}

	return o.BillingContact
}

// GetBillingContactOk returns a tuple with the BillingContact field value
// and a boolean to check if the value has been set.
func (o *CreatePrintOrderRequestProductionData) GetBillingContactOk() (*PolyprintContact, bool) {
	if o == nil {
		return nil, false
	}
	return &o.BillingContact, true
}

// SetBillingContact sets field value
func (o *CreatePrintOrderRequestProductionData) SetBillingContact(v PolyprintContact) {
	o.BillingContact = v
}

// GetExpectedDeliveryDate returns the ExpectedDeliveryDate field value
// If the value is explicit nil, the zero value for interface{} will be returned
func (o *CreatePrintOrderRequestProductionData) GetExpectedDeliveryDate() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}

	return o.ExpectedDeliveryDate
}

// GetExpectedDeliveryDateOk returns a tuple with the ExpectedDeliveryDate field value
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CreatePrintOrderRequestProductionData) GetExpectedDeliveryDateOk() (*interface{}, bool) {
	if o == nil || IsNil(o.ExpectedDeliveryDate) {
		return nil, false
	}
	return &o.ExpectedDeliveryDate, true
}

// SetExpectedDeliveryDate sets field value
func (o *CreatePrintOrderRequestProductionData) SetExpectedDeliveryDate(v interface{}) {
	o.ExpectedDeliveryDate = v
}

// GetNfcCode returns the NfcCode field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *CreatePrintOrderRequestProductionData) GetNfcCode() interface{} {
	if o == nil {
		var ret interface{}
		return ret
	}
	return o.NfcCode
}

// GetNfcCodeOk returns a tuple with the NfcCode field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *CreatePrintOrderRequestProductionData) GetNfcCodeOk() (*interface{}, bool) {
	if o == nil || IsNil(o.NfcCode) {
		return nil, false
	}
	return &o.NfcCode, true
}

// HasNfcCode returns a boolean if a field has been set.
func (o *CreatePrintOrderRequestProductionData) HasNfcCode() bool {
	if o != nil && IsNil(o.NfcCode) {
		return true
	}

	return false
}

// SetNfcCode gets a reference to the given interface{} and assigns it to the NfcCode field.
func (o *CreatePrintOrderRequestProductionData) SetNfcCode(v interface{}) {
	o.NfcCode = v
}

func (o CreatePrintOrderRequestProductionData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreatePrintOrderRequestProductionData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.ReferenceId != nil {
		toSerialize["referenceId"] = o.ReferenceId
	}
	if o.Date != nil {
		toSerialize["date"] = o.Date
	}
	if o.ProductId != nil {
		toSerialize["productId"] = o.ProductId
	}
	if o.Quantity != nil {
		toSerialize["quantity"] = o.Quantity
	}
	toSerialize["deliveryContact"] = o.DeliveryContact
	toSerialize["billingContact"] = o.BillingContact
	if o.ExpectedDeliveryDate != nil {
		toSerialize["expectedDeliveryDate"] = o.ExpectedDeliveryDate
	}
	if o.NfcCode != nil {
		toSerialize["nfcCode"] = o.NfcCode
	}
	return toSerialize, nil
}

type NullableCreatePrintOrderRequestProductionData struct {
	value *CreatePrintOrderRequestProductionData
	isSet bool
}

func (v NullableCreatePrintOrderRequestProductionData) Get() *CreatePrintOrderRequestProductionData {
	return v.value
}

func (v *NullableCreatePrintOrderRequestProductionData) Set(val *CreatePrintOrderRequestProductionData) {
	v.value = val
	v.isSet = true
}

func (v NullableCreatePrintOrderRequestProductionData) IsSet() bool {
	return v.isSet
}

func (v *NullableCreatePrintOrderRequestProductionData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreatePrintOrderRequestProductionData(val *CreatePrintOrderRequestProductionData) *NullableCreatePrintOrderRequestProductionData {
	return &NullableCreatePrintOrderRequestProductionData{value: val, isSet: true}
}

func (v NullableCreatePrintOrderRequestProductionData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreatePrintOrderRequestProductionData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


